<template>
    <div class="content-block">
        <div class="container">
            <!--<div class="margin-top-50"></div>-->
            <div class="row">
                <div class="columns twelve central-column">
                    <div class="content">
                        <h3 class="main-header">Подтверждение Email</h3>
                    </div>
                    <div class="white-block">
                        <div class="padding">
                            <template  v-if="!hasError">
                                <div class="row success-block">
                                    <b>{{title}}</b>
                                    <div v-html="message"></div>
                                </div>
                                <button @click="returnToProfile" v-if="message && !$auth.isAuth">Войти в ЛК</button>

                            </template>

                            <div v-else class="warning-block">
                                <b>{{title}}</b>
                                <br>
                                <div v-html="message"></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import ToggleChat from '@/mixins/Chat/ToggleChat'

    export default {
        mixins: [ToggleChat],
        name: 'email-confirm',

        data() {
            return {
                message: '',
                hasError: false
            }
        },

        computed: {
            title() {
                return this.hasError ? 'Произошла ошибка' : 'Успешно'
            }
        },

        methods: {
            returnToProfile() {
                this.$router.push('profile')
            }
        },

        created() {
            if (this.$route.query.hash) {
                this.$store.commit('AJAX_LOADING', true);
                this.$backend.api.user.email.confirm(this.$route.query.hash).then(({data}) => {
                    if (this.$auth.isAuth) {
                        this.message = `Ваш email ${this.$user.email} подтвержден.`
                        this.$user.emailConfirmed = 1;
                    } else {
                        this.message = `Ваш email подтвержден.`;
                        this.hasError = false;
                        setTimeout(() => {
                            this.$router.push({name: 'login'})
                        }, 10000);
                    }
                }).catch((e) => {
                    const error = this.$getErrorCode(e)
                    this.hasError = true;
                    switch (error) {
                        case 'emailHashInvalid':
                            this.message = `Не удалось подтвердить email. Возможно, вы не полностью скопировали ссылку.<br>Если вам нужна помощь, то обратитесь в <a href="#" class="link" id="open-help-chat">онлайн-чат</a>.`
                            this.$nextTick(() => {
                                document.querySelector('#open-help-chat').addEventListener('click', (e) => {
                                    e.preventDefault()
                                    this.toggleChat()
                                })
                            })
                            break;
                        case 'emailDoNotHaveRecoveryEmail':
                            this.message = 'Ваш email уже подтвержден';
                            break;
                    }
                }).finally(() => {
                    this.$store.commit('AJAX_LOADING', false)
                })
            }
        }
    }
</script>

<style scoped>

</style>
